Package: truncProxy
Type: Package
Title: Proximal Weighting Estimation for Dependent Left Truncation
Version: 0.1.0
Authors@R: c(
    person("Yuyao", "Wang", email = "yuw079@ucsd.edu", role = c("aut", "cre")),
    person("Andrew", "Ying", role = "aut"),
    person("Ronghui", "Xu", role = "aut")
    )
Description: Implements proximal weighting estimators for the expectation
    of an arbitrarily transformed event time under dependent left truncation,
    with optional inverse probability of censoring weighting to handle right
    censoring. The methods leverage proxy variables to handle dependent left
    truncation in settings where dependence-inducing factors are not fully
    observed.
License: GPL-3
Encoding: UTF-8
Depends: R (>= 4.1.0)
Imports: Rcpp, survival
LinkingTo: Rcpp, RcppArmadillo
Suggests: testthat (>= 3.0.0)
Config/testthat/edition: 3
URL: https://github.com/wangyuyao98/truncProxy_weighting,
        https://arxiv.org/pdf/2512.21283
BugReports: https://github.com/wangyuyao98/truncProxy_weighting/issues
RoxygenNote: 7.3.2
NeedsCompilation: yes
Packaged: 2026-04-19 18:10:14 UTC; yuyaowang
Author: Yuyao Wang [aut, cre],
  Andrew Ying [aut],
  Ronghui Xu [aut]
Maintainer: Yuyao Wang <yuw079@ucsd.edu>
Repository: CRAN
Date/Publication: 2026-04-21 20:40:09 UTC
Built: R 4.4.3; x86_64-apple-darwin20; 2026-04-21 21:31:25 UTC; unix
Archs: truncProxy.so.dSYM

Package: truncProxy
Type: Package
Title: Proximal Weighting Estimation for Dependent Left Truncation
Version: 0.1.0
Authors@R: c(
    person("Yuyao", "Wang", email = "yuw079@ucsd.edu", role = c("aut", "cre")),
    person("Andrew", "Ying", role = "aut"),
    person("Ronghui", "Xu", role = "aut")
    )
Description: Implements proximal weighting estimators for the expectation
    of an arbitrarily transformed event time under dependent left truncation,
    with optional inverse probability of censoring weighting to handle right
    censoring. The methods leverage proxy variables to handle dependent left
    truncation in settings where dependence-inducing factors are not fully
    observed.
License: GPL-3
Encoding: UTF-8
Depends: R (>= 4.1.0)
Imports: Rcpp, survival
LinkingTo: Rcpp, RcppArmadillo
Suggests: testthat (>= 3.0.0)
Config/testthat/edition: 3
URL: https://github.com/wangyuyao98/truncProxy_weighting,
        https://arxiv.org/pdf/2512.21283
BugReports: https://github.com/wangyuyao98/truncProxy_weighting/issues
RoxygenNote: 7.3.2
NeedsCompilation: yes
Packaged: 2026-04-19 18:10:14 UTC; yuyaowang
Author: Yuyao Wang [aut, cre],
  Andrew Ying [aut],
  Ronghui Xu [aut]
Maintainer: Yuyao Wang <yuw079@ucsd.edu>
Repository: CRAN
Date/Publication: 2026-04-21 20:40:09 UTC
Built: R 4.6.0; aarch64-apple-darwin23; 2026-04-26 05:06:33 UTC; unix
Archs: truncProxy.so.dSYM

# truncProxy

`truncProxy` implements proximal weighting estimators for the expectation of an
arbitrarily transformed event time under dependent left truncation, with
optional inverse probability of censoring weighting to handle right censoring.

The current package exports:

- `PQB_estimator()`
- `PQB_IPCW_estimator()`

The associated paper is available at <https://arxiv.org/pdf/2512.21283>.

## Installation

Once the package is published on CRAN, it can be installed with:

```r
install.packages("truncProxy")
```

During development, it can also be installed from GitHub with:

```r
devtools::install_github("wangyuyao98/truncProxy_weighting", subdir = "pkg/truncProxy")
```

During development from this repository root, it can be installed with:

```r
devtools::install("pkg/truncProxy")
```

## Simulation-Based Example

```r
library(truncProxy)

simulate_truncproxy_data <- function(n = 300, multi = 20) {
  para_set <- list(
    mu_Z = 0.6,
    sigma_Z = 0.45,
    mu_U = 0.6,
    sigma_U = 0.45,
    mu_W1 = c(1.4, 0.3, -0.9),
    sigma_W1 = 0.25,
    mu_W2 = c(0.6, -0.2, 0.5),
    sigma_W2 = 0.25,
    mu_Q = c(0.1, 0.25, 1),
    mu_TT = c(0.25, 0.3, 0.6),
    T.min = 0,
    Q.max = 2,
    shape_D = 2,
    scale_D = 2
  )

  Z <- pmax(0, para_set$mu_Z + rnorm(multi * n, 0, para_set$sigma_Z))
  U <- pmax(0, para_set$mu_U + rnorm(multi * n, 0, para_set$sigma_U))
  W1 <- cbind(1, Z, U) %*% para_set$mu_W1 + rnorm(multi * n, 0, para_set$sigma_W1)
  W2 <- cbind(1, Z, U) %*% para_set$mu_W2 + rnorm(multi * n, 0, para_set$sigma_W2)
  TT <- para_set$T.min + rexp(multi * n, cbind(1, Z, U) %*% para_set$mu_TT)

  tau <- para_set$Q.max
  Q2 <- rexp(multi * n, cbind(1, Z, U) %*% para_set$mu_Q)
  Q2 <- pmin(Q2, tau)
  Q <- tau - Q2

  D <- rweibull(n, shape = para_set$shape_D, scale = para_set$scale_D)
  C <- Q + D
  X <- pmin(TT, C)
  delta <- as.integer(TT < C)

  dat_full <- data.frame(X = X, TT = TT, delta = delta, Q = Q, W1 = W1, W2 = W2, Z = Z)
  dat_obs <- dat_full[dat_full$Q < dat_full$TT, , drop = FALSE]
  dat_obs[seq_len(n), , drop = FALSE]
}

set.seed(1)
dat <- simulate_truncproxy_data()
nu <- function(t) as.numeric(t > 1)

PQB_estimator(
  nu = nu,
  dat = dat,
  time.name = "TT",
  Q.name = "Q",
  W1.name = "W1",
  W2.name = "W2",
  Z.name = "Z"
)

PQB_IPCW_estimator(
  nu = nu,
  t0 = 1,
  dat = dat,
  time.name = "X",
  Q.name = "Q",
  event.name = "delta",
  W1.name = "W1",
  W2.name = "W2",
  Z.name = "Z",
  IPCW_time_varying = TRUE
)
```

## Notes

In the current implementation, the IPCW weights are computed from a weighted
Kaplan-Meier estimator on the residual time scale `time - Q`.

# Evaluate the integrated bridge process at subject-specific time points.
B_int_eval <- function(time.eval, B_int, qtime) {
  if (length(time.eval) != nrow(B_int)) {
    stop("The number of time points does not equal the number of subjects!")
  }

  if (ncol(B_int) != (length(qtime) + 1)) {
    stop(
      paste(
        "ncol(B_int) should equal length(qtime) + 1, where the last column",
        "of B_int corresponds to the time in the initial condition."
      )
    )
  }

  probs <- rep(NA_real_, length(time.eval))
  for (i in seq_along(time.eval)) {
    id <- findInterval(time.eval[i], c(0, qtime, Inf))
    probs[i] <- B_int[i, id]
  }

  probs
}

#' Proximal Weighting Estimation Under Dependent Left Truncation
#'
#' Computes the proximal weighting estimator for the expectation of an
#' arbitrarily transformed event time under dependent left truncation.
#'
#' @param nu A user-supplied transformation of the event time. For example,
#'   `function(t) as.numeric(t > tau)` results in estimating a survival
#'   probability beyond time `tau`.
#' @param dat A data frame containing the observed data.
#' @param time.name Name of the event time variable.
#' @param Q.name Name of the left truncation time variable.
#' @param W1.name Name of the truncation proxies.
#' @param W2.name Name of the event time proxies.
#' @param Z.name Name of the measured covariates that are directly associated with both the event time and the truncation time.
#' @param weights Optional nonnegative case weights. Defaults to equal weights.
#' @param trim.min Lower bound used to stabilize the estimated bridge weights.
#' @param trim.max Upper bound used to stabilize the estimated bridge weights.
#'
#' @return A numeric scalar containing the proximal weighting estimator.
#' @export
PQB_estimator <- function(nu, dat, time.name, Q.name, W1.name, W2.name, Z.name,
                          weights = rep(1, nrow(dat)),
                          trim.min = 1e-7, trim.max = 1e7) {
  TT <- dat[, time.name]
  Q <- dat[, Q.name]
  q_Z <- as.matrix(cbind(1, dat[, W1.name], dat[, Z.name]))
  colnames(q_Z) <- c("1", W1.name, Z.name)
  q_W <- as.matrix(cbind(1, dat[, W2.name], dat[, Z.name]))
  colnames(q_W) <- c("1", W2.name, Z.name)

  v <- sort(unique(Q))
  qtime.id <- (min(TT) <= v & v <= max(TT))
  qtime <- v[qtime.id]

  qfit <- qbridge(TT = TT, Q = Q, qtime = qtime, Z = q_Z, W = q_W, weights = weights)
  B_int <- qfit$B_int
  qtime <- qfit$qtime

  bT_hat <- exp(B_int_eval(TT, B_int, qtime))
  bT_hat <- pmin(pmax(bT_hat, trim.min), trim.max)

  numer <- mean(weights * bT_hat * nu(TT))
  denom <- mean(weights * bT_hat)

  numer / denom
}

paper_like_parameters <- function() {
  list(
    mu_Z = 0.6,
    sigma_Z = 0.45,
    mu_U = 0.6,
    sigma_U = 0.45,
    mu_W1 = c(1.4, 0.3, -0.9),
    sigma_W1 = 0.25,
    mu_W2 = c(0.6, -0.2, 0.5),
    sigma_W2 = 0.25,
    mu_Q = c(0.1, 0.25, 1),
    mu_TT = c(0.25, 0.3, 0.6),
    T.min = 0,
    Q.max = 2,
    shape_D = 2,
    scale_D = 2
  )
}

make_example_data <- function(n = 120L, multi = 20L) {
  set.seed(1)
  para_set <- paper_like_parameters()

  Z <- pmax(0, para_set$mu_Z + rnorm(multi * n, 0, para_set$sigma_Z))
  U <- pmax(0, para_set$mu_U + rnorm(multi * n, 0, para_set$sigma_U))

  W1 <- cbind(1, Z, U) %*% para_set$mu_W1 + rnorm(multi * n, 0, para_set$sigma_W1)
  W2 <- cbind(1, Z, U) %*% para_set$mu_W2 + rnorm(multi * n, 0, para_set$sigma_W2)

  TT <- para_set$T.min + rexp(multi * n, cbind(1, Z, U) %*% para_set$mu_TT)

  tau <- para_set$Q.max
  Q2 <- rexp(multi * n, cbind(1, Z, U) %*% para_set$mu_Q)
  Q2 <- pmin(Q2, tau)
  Q <- tau - Q2

  D <- rweibull(n, shape = para_set$shape_D, scale = para_set$scale_D)
  C <- Q + D
  X <- pmin(TT, C)
  delta <- as.integer(TT < C)

  dat_full <- data.frame(X = X, TT = TT, delta = delta, Q = Q, W1 = W1, W2 = W2, Z = Z)
  dat_obs <- dat_full[dat_full$Q < dat_full$TT, , drop = FALSE]
  if (nrow(dat_obs) < n) {
    stop("Truncation rate is high. Increase `multi` in the test helper.")
  }

  dat_obs[seq_len(n), , drop = FALSE]
}

expected_example_results <- c(
  pqb = 0.46829407648884236,
  pqb_ipcw_case = 0.50071856411755766,
  pqb_ipcw_time_varying = 0.50802764944146661
)

test_that("PQB_estimator matches a fixed regression target", {
  dat <- make_example_data()
  nu <- function(t) as.numeric(t > 1)

  est <- PQB_estimator(
    nu = nu,
    dat = dat,
    time.name = "TT",
    Q.name = "Q",
    W1.name = "W1",
    W2.name = "W2",
    Z.name = "Z"
  )

  expect_equal(est, unname(expected_example_results["pqb"]), tolerance = 1e-12)
})

test_that("PQB_IPCW_estimator with case weights matches a fixed regression target", {
  dat <- make_example_data()
  nu <- function(t) as.numeric(t > 1)

  est <- PQB_IPCW_estimator(
    nu = nu,
    t0 = 1,
    dat = dat,
    time.name = "X",
    Q.name = "Q",
    event.name = "delta",
    W1.name = "W1",
    W2.name = "W2",
    Z.name = "Z",
    IPCW_time_varying = FALSE
  )

  expect_equal(est, unname(expected_example_results["pqb_ipcw_case"]), tolerance = 1e-12)
})

test_that("PQB_IPCW_estimator with time-varying weights matches a fixed regression target", {
  dat <- make_example_data()
  nu <- function(t) as.numeric(t > 1)

  est <- PQB_IPCW_estimator(
    nu = nu,
    t0 = 1,
    dat = dat,
    time.name = "X",
    Q.name = "Q",
    event.name = "delta",
    W1.name = "W1",
    W2.name = "W2",
    Z.name = "Z",
    IPCW_time_varying = TRUE
  )

  expect_equal(est, unname(expected_example_results["pqb_ipcw_time_varying"]), tolerance = 1e-12)
})

#' IPCW-Adjusted Proximal Weighting Estimation under Dependent Left Truncation and Random Right Censoring
#'
#' Computes the IPCW-adjusted proximal weighting estimator for the expectation
#' of an arbitrarily transformed event time under dependent left truncation
#' and random right censoring.
#'
#' @param nu A user-supplied transformation of the event time. For example,
#'   `function(t) as.numeric(t > tau)` results in estimating a survival
#'   probability beyond time `tau`.
#' @param t0 A cutoff such that `nu(t) = nu(min(t, t0))`. For example, for
#'   survival probability at time `tau`, one can set `t0 = tau`.
#' @param dat A data frame containing the observed data.
#' @param time.name Name of the observed event or censoring time variable.
#' @param Q.name Name of the left truncation time variable.
#' @param event.name Name of the event indicator variable. Set to `NULL` when
#'   there is no right censoring.
#' @param W1.name Name of the truncation proxies.
#' @param W2.name Name of the event time proxies.
#' @param Z.name Name of the measured covariates that are directly associated with both the event time and the truncation time.
#' @param weights Optional nonnegative case weights. Defaults to equal weights.
#' @param trim.min Lower bound used to stabilize the estimated bridge weights.
#' @param trim.max Upper bound used to stabilize the estimated bridge weights.
#' @param IPCW_time_varying Logical; if `TRUE`, use time-varying IPCW weights in
#'   the bridge estimation step.
#' @param trim.IPCW Lower bound used to stabilize the denominators of IPCW weights.
#'
#' @return A numeric scalar containing the IPCW-adjusted proximal weighting
#'   estimator.
#' @export
PQB_IPCW_estimator <- function(nu, t0, dat, time.name, Q.name, event.name = NULL,
                               W1.name, W2.name, Z.name,
                               weights = rep(1, nrow(dat)),
                               trim.min = 1e-7, trim.max = 1e7,
                               IPCW_time_varying = FALSE, trim.IPCW = 1e-7) {
  names_used <- c(time.name, Q.name, W1.name, W2.name, Z.name)
  if (sum(names_used == "weights") > 0) {
    stop("The names of the variables cannot be 'weights', which is used in the middle of computation")
  } else if (sum(names_used == "IPCW_weights") > 0) {
    stop("The names of the variables cannot be 'IPCW_weights', which is used in the middle of computation")
  }

  if (is.null(event.name)) {
    if (sum(names_used == "delta1") > 0) {
      stop("The names of the variables cannot be 'delta1', which is used in the middle of computation")
    }
    event.name <- "delta1"
    dat$delta1 <- rep(1, nrow(dat))
  }

  Y <- dat[, time.name] - dat[, Q.name]
  delta_C <- 1 - dat[, event.name]
  fitD <- survival::survfit(
    survival::Surv(Y, delta_C) ~ 1,
    type = "kaplan-meier",
    weights = weights
  )
  stepfunD <- stats::stepfun(fitD$time, c(1, fitD$surv))

  if (IPCW_time_varying) {
    X <- dat[, time.name]
    Q <- dat[, Q.name]
    q_Z <- as.matrix(cbind(1, dat[, W1.name], dat[, Z.name]))
    colnames(q_Z) <- c("1", W1.name, Z.name)
    q_W <- as.matrix(cbind(1, dat[, W2.name], dat[, Z.name]))
    colnames(q_W) <- c("1", W2.name, Z.name)

    v <- sort(unique(Q))
    qtime.id <- (min(X) <= v & v <= max(X))
    qtime <- v[qtime.id]

    IPCW_weights_mx <- matrix(nrow = nrow(dat), ncol = length(qtime))
    delta_t_mx <- matrix(nrow = nrow(dat), ncol = length(qtime))
    for (j in seq_along(qtime)) {
      temp_time <- qtime[j]
      delta_t_mx[, j] <- as.numeric(dat[, event.name] == 1 | X > temp_time)
      IPCW_weights_mx[, j] <- delta_t_mx[, j] / pmax(stepfunD(pmin(X, temp_time) - Q), trim.IPCW)
    }

    qfit <- qbridge_IPCW(
      TT = X,
      Q = Q,
      qtime = qtime,
      Z = q_Z,
      W = q_W,
      IPCW_weights = IPCW_weights_mx,
      weights = weights
    )
    B_int <- qfit$B_int
    qtime <- qfit$qtime

    bT_hat <- exp(B_int_eval(X, B_int, qtime))
    bT_hat <- pmin(pmax(bT_hat, trim.min), trim.max)

    Q_max <- max(Q)
    tau_delta <- max(Q_max, t0)
    delta_t <- as.numeric(dat[, event.name] == 1 | X > tau_delta)
    IPCW_weights <- delta_t / pmax(stepfunD(pmin(X, tau_delta) - Q), trim.IPCW)
    numer <- mean(weights * IPCW_weights * bT_hat * nu(X))
    denom <- mean(weights * IPCW_weights * bT_hat)

    est <- numer / denom
  } else {
    X <- dat[, time.name]
    Q <- dat[, Q.name]

    Q_max <- max(Q)
    tau_delta <- max(Q_max, t0)
    delta_t <- as.numeric(dat[, event.name] == 1 | X > tau_delta)
    IPCW_weights <- delta_t / pmax(stepfunD(pmin(X, tau_delta) - Q), trim.IPCW)

    est <- PQB_estimator(
      nu = nu,
      dat = dat,
      time.name = time.name,
      Q.name = Q.name,
      W1.name = W1.name,
      W2.name = W2.name,
      Z.name = Z.name,
      weights = weights * IPCW_weights,
      trim.min = trim.min,
      trim.max = trim.max
    )
  }

  est
}

#' truncProxy: Proximal Weighting Estimation for Dependent Left Truncation
#'
#' Implements proximal weighting estimators for the expectation of an
#' arbitrarily transformed event time under dependent left truncation, with
#' optional inverse probability of censoring weighting to handle right
#' censoring. The methods leverage proxy variables to handle dependent left
#' truncation in settings where dependence-inducing factors are not fully
#' observed.
#'
#' @keywords internal
#' @useDynLib truncProxy, .registration = TRUE
#' @importFrom Rcpp evalCpp
"_PACKAGE"

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

qbridge <- function(TT, Q, qtime, Z, W, weights, tol = 0.001) {
    .Call('_truncProxy_qbridge', PACKAGE = 'truncProxy', TT, Q, qtime, Z, W, weights, tol)
}

qbridge_IPCW <- function(TT, Q, qtime, Z, W, IPCW_weights, weights, tol = 0.001) {
    .Call('_truncProxy_qbridge_IPCW', PACKAGE = 'truncProxy', TT, Q, qtime, Z, W, IPCW_weights, weights, tol)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PQB_IPCW_estimator.R
\name{PQB_IPCW_estimator}
\alias{PQB_IPCW_estimator}
\title{IPCW-Adjusted Proximal Weighting Estimation under Dependent Left Truncation and Random Right Censoring}
\usage{
PQB_IPCW_estimator(
  nu,
  t0,
  dat,
  time.name,
  Q.name,
  event.name = NULL,
  W1.name,
  W2.name,
  Z.name,
  weights = rep(1, nrow(dat)),
  trim.min = 1e-07,
  trim.max = 1e+07,
  IPCW_time_varying = FALSE,
  trim.IPCW = 1e-07
)
}
\arguments{
\item{nu}{A user-supplied transformation of the event time. For example,
\code{function(t) as.numeric(t > tau)} results in estimating a survival
probability beyond time \code{tau}.}

\item{t0}{A cutoff such that \code{nu(t) = nu(min(t, t0))}. For example, for
survival probability at time \code{tau}, one can set \code{t0 = tau}.}

\item{dat}{A data frame containing the observed data.}

\item{time.name}{Name of the observed event or censoring time variable.}

\item{Q.name}{Name of the left truncation time variable.}

\item{event.name}{Name of the event indicator variable. Set to \code{NULL} when
there is no right censoring.}

\item{W1.name}{Name of the truncation proxies.}

\item{W2.name}{Name of the event time proxies.}

\item{Z.name}{Name of the measured covariates that are directly associated with both the event time and the truncation time.}

\item{weights}{Optional nonnegative case weights. Defaults to equal weights.}

\item{trim.min}{Lower bound used to stabilize the estimated bridge weights.}

\item{trim.max}{Upper bound used to stabilize the estimated bridge weights.}

\item{IPCW_time_varying}{Logical; if \code{TRUE}, use time-varying IPCW weights in
the bridge estimation step.}

\item{trim.IPCW}{Lower bound used to stabilize the denominators of IPCW weights.}
}
\value{
A numeric scalar containing the IPCW-adjusted proximal weighting
estimator.
}
\description{
Computes the IPCW-adjusted proximal weighting estimator for the expectation
of an arbitrarily transformed event time under dependent left truncation
and random right censoring.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/truncProxy-package.R
\docType{package}
\name{truncProxy-package}
\alias{truncProxy}
\alias{truncProxy-package}
\title{truncProxy: Proximal Weighting Estimation for Dependent Left Truncation}
\description{
Implements proximal weighting estimators for the expectation of an
arbitrarily transformed event time under dependent left truncation, with
optional inverse probability of censoring weighting to handle right
censoring. The methods leverage proxy variables to handle dependent left
truncation in settings where dependence-inducing factors are not fully
observed.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/wangyuyao98/truncProxy_weighting}
  \item \url{https://arxiv.org/pdf/2512.21283}
  \item Report bugs at \url{https://github.com/wangyuyao98/truncProxy_weighting/issues}
}

}
\author{
\strong{Maintainer}: Yuyao Wang \email{yuw079@ucsd.edu}

Authors:
\itemize{
  \item Andrew Ying
  \item Ronghui Xu
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/PQB_estimator.R
\name{PQB_estimator}
\alias{PQB_estimator}
\title{Proximal Weighting Estimation Under Dependent Left Truncation}
\usage{
PQB_estimator(
  nu,
  dat,
  time.name,
  Q.name,
  W1.name,
  W2.name,
  Z.name,
  weights = rep(1, nrow(dat)),
  trim.min = 1e-07,
  trim.max = 1e+07
)
}
\arguments{
\item{nu}{A user-supplied transformation of the event time. For example,
\code{function(t) as.numeric(t > tau)} results in estimating a survival
probability beyond time \code{tau}.}

\item{dat}{A data frame containing the observed data.}

\item{time.name}{Name of the event time variable.}

\item{Q.name}{Name of the left truncation time variable.}

\item{W1.name}{Name of the truncation proxies.}

\item{W2.name}{Name of the event time proxies.}

\item{Z.name}{Name of the measured covariates that are directly associated with both the event time and the truncation time.}

\item{weights}{Optional nonnegative case weights. Defaults to equal weights.}

\item{trim.min}{Lower bound used to stabilize the estimated bridge weights.}

\item{trim.max}{Upper bound used to stabilize the estimated bridge weights.}
}
\value{
A numeric scalar containing the proximal weighting estimator.
}
\description{
Computes the proximal weighting estimator for the expectation of an
arbitrarily transformed event time under dependent left truncation.
}
